Bug 731197 - RFE: add renegotiation constants to python-nss
Summary: RFE: add renegotiation constants to python-nss
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: python-nss
Version: 15
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: John Dennis
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 786498
TreeView+ depends on / blocked
 
Reported: 2011-08-16 21:52 UTC by Rob Crittenden
Modified: 2013-01-10 06:39 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-08-07 19:52:14 UTC


Attachments (Terms of Use)

Description Rob Crittenden 2011-08-16 21:52:02 UTC
Description of problem:

NSS defines two knobs for tuning renegotiation. It would be nice to have constants for these defined in python-nss (it is possible to set these using numeric values directly but constants make for better code).

These are the two knobs (from nss3/ssl.h)

#define SSL_ENABLE_RENEGOTIATION       20 /* Values below (default: never)  */
#define SSL_REQUIRE_SAFE_NEGOTIATION   21 /* Peer must send Signaling       */
                                          /* Cipher Suite Value (SCSV) or   */
                                          /* Renegotiation  Info (RI)       */
                                          /* extension in ALL handshakes.   */
                                          /* default: off                   */

These are the values for SSL_ENABLE_RENEGOTIATION

/* Values for "on" with SSL_ENABLE_RENEGOTIATION */
/* Never renegotiate at all.                                               */
#define SSL_RENEGOTIATE_NEVER        ((PRBool)0)
/* Renegotiate without restriction, whether or not the peer's client hello */
/* bears the renegotiation info extension.  Vulnerable, as in the past.    */
#define SSL_RENEGOTIATE_UNRESTRICTED ((PRBool)1)
/* Only renegotiate if the peer's hello bears the TLS renegotiation_info   */
/* extension. This is safe renegotiation.                                  */
#define SSL_RENEGOTIATE_REQUIRES_XTN ((PRBool)2)
/* Disallow unsafe renegotiation in server sockets only, but allow clients */
/* to continue to renegotiate with vulnerable servers.                     */
/* This value should only be used during the transition period when few    */
/* servers have been upgraded.                                             */
#define SSL_RENEGOTIATE_TRANSITIONAL ((PRBool)3)

Version-Release number of selected component (if applicable):

python-nss-0.11-2.fc15.x86_64

Comment 1 John Dennis 2011-08-16 22:14:58 UTC
Rob:

IPA is currently at 0.11, current python-nss is 0.12. Do you see a problem with requiring 0.13 or would you prefer to backport into 0.11 for both Fedora and RHEL?

As a side note 0.12 introduced PKCS12 support but that didn't provide access to the private key because I couldn't figure out how to do it.

However Miloslav Trmac has demonstrated it can be done by wrapping the key in a NULL symmetric key and provided me with example code. Would it make sense to produce a 0.13 with the new constants and Miloslav's PKC12 private key export logic? If so we should probably open a new ticket for that and make one a blocker. (Caveat: I haven't studied Miloslav's code yet so I can't make any promises).

Comment 2 Rob Crittenden 2011-08-17 17:29:01 UTC
I'm ok with bumping up the requires.

If you can get the PKCS12 keys done soon then yes, we may have time to incorporate it into IPA. The IPA side should be relatively straightforward, what can be time consuming is setting up the environment to test.

Comment 3 Fedora End Of Life 2012-08-07 19:52:16 UTC
This message is a notice that Fedora 15 is now at end of life. Fedora
has stopped maintaining and issuing updates for Fedora 15. It is
Fedora's policy to close all bug reports from releases that are no
longer maintained. At this time, all open bugs with a Fedora 'version'
of '15' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that
we were unable to fix it before Fedora 15 reached end of life. If you
would still like to see this bug fixed and are able to reproduce it
against a later version of Fedora, you are encouraged to click on
"Clone This Bug" (top right of this page) and open it against that
version of Fedora.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

The process we are following is described here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping


Note You need to log in before you can comment on or make changes to this bug.